// CatchMeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CatchMe.h"
#include "CatchMeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCatchMeDlg dialog

CCatchMeDlg::CCatchMeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCatchMeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCatchMeDlg)
	m_strCoOrdinates = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCatchMeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCatchMeDlg)
	DDX_Control(pDX, IDC_BUTTON_CLICK_ME, m_ctrlClickMe);
	DDX_Text(pDX, IDC_STATIC_CO_ORDINATES, m_strCoOrdinates);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCatchMeDlg, CDialog)
	//{{AFX_MSG_MAP(CCatchMeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCatchMeDlg message handlers

BOOL CCatchMeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCatchMeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCatchMeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCatchMeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCatchMeDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	static int iCounter=0;
	
	CRect MainWindowRect;
	CRect ButtonRect,DialogButtonRect;
	WINDOWPLACEMENT ButtonPlacement;
	GetClientRect(MainWindowRect);
	m_ctrlClickMe.GetWindowRect(ButtonRect);
	m_ctrlClickMe.GetWindowPlacement(&ButtonPlacement); 
	DialogButtonRect=ButtonPlacement.rcNormalPosition; 
	m_strCoOrdinates.Format("X=%d,Y=%d, Button Left=%d, Button Top=%d",point.x,point.y,DialogButtonRect.left ,DialogButtonRect.top);
	UpdateData(FALSE);
	//Check whther the Mosuse point is inside button rect
	if((abs(point.x- DialogButtonRect.left)<=2)||(abs(point.y- DialogButtonRect.top)<=2))
	
	{
		switch(iCounter)
		{
		case 0:
			//ButtonRect.OffsetRect(MainWindowRect.left,MainWindowRect.top); 
			iCounter=1;
			break;
       case 1:
		   iCounter=2;
		   //ButtonRect.OffsetRect(MainWindowRect.left,MainWindowRect.bottom); 
			break;
		case 2:
			iCounter=3;
			break;
		case 3:
			iCounter=4;
			break;
		case 4:
			iCounter=0;
			break;	
		}
		DialogButtonRect.OffsetRect(DialogButtonRect.left-1,DialogButtonRect.top-1);
		
		m_ctrlClickMe.MoveWindow(DialogButtonRect); 
		 	
	}
	CDialog::OnMouseMove(nFlags, point);
}
