// MatrixGridView.h : interface of the CMatrixGridView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATRIXGRIDVIEW_H__B06A1463_D468_4811_88CE_D8844D58F4FE__INCLUDED_)
#define AFX_MATRIXGRIDVIEW_H__B06A1463_D468_4811_88CE_D8844D58F4FE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMatrixGridView : public CScrollView
{
protected: // create from serialization only
	CMatrixGridView();
	DECLARE_DYNCREATE(CMatrixGridView)

// Attributes
public:
	CMatrixGridDoc* GetDocument();

// Operations
public:
	int m_iRowIndex;
	int m_iColIndex;
	int m_iSelCol;
	int m_iSelRow;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMatrixGridView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void DeleteWindow();
	void FillColor(CDC *pDC);
	void InitializeCell();
	void SetScrollPosition();
	void DrawGrid(CDC *pDC);
	virtual ~CMatrixGridView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMatrixGridView)
	afx_msg void OnZoom25();
	afx_msg void OnZoom50();
	afx_msg void OnZoom200();
	afx_msg void OnZoom100();
	afx_msg void OnEditUndo();
	afx_msg void OnEditPaste();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPopupColour();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnEditClearcell();
	afx_msg void OnEditCustomize();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MatrixGridView.cpp
inline CMatrixGridDoc* CMatrixGridView::GetDocument()
   { return (CMatrixGridDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MATRIXGRIDVIEW_H__B06A1463_D468_4811_88CE_D8844D58F4FE__INCLUDED_)
