// MatrixGridView.cpp : implementation of the CMatrixGridView class
//

#include "stdafx.h"
#include "MatrixGrid.h"

#include "MatrixGridDoc.h"
#include "MatrixGridView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView

IMPLEMENT_DYNCREATE(CMatrixGridView, CScrollView)

BEGIN_MESSAGE_MAP(CMatrixGridView, CScrollView)
	//{{AFX_MSG_MAP(CMatrixGridView)
	ON_COMMAND(ID_ZOOM_25, OnZoom25)
	ON_COMMAND(ID_ZOOM_50, OnZoom50)
	ON_COMMAND(ID_ZOOM_200, OnZoom200)
	ON_COMMAND(ID_ZOOM_100, OnZoom100)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView construction/destruction

CMatrixGridView::CMatrixGridView()
{
	// TODO: add construction code here

}

CMatrixGridView::~CMatrixGridView()
{
}

BOOL CMatrixGridView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView drawing

void CMatrixGridView::OnDraw(CDC* pDC)
{
	CMatrixGridDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	DrawGrid(pDC);
	
}


void CMatrixGridView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView printing

BOOL CMatrixGridView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMatrixGridView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMatrixGridView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView diagnostics

#ifdef _DEBUG
void CMatrixGridView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMatrixGridView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMatrixGridDoc* CMatrixGridView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMatrixGridDoc)));
	return (CMatrixGridDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView message handlers

void CMatrixGridView::DrawGrid(CDC *pDC)
{
	CMatrixGridDoc *pDoc=GetDocument();
    int iIndex;
	for(iIndex=0;iIndex<=pDoc->m_iColoums;iIndex++)
	{
		pDC->MoveTo(pDoc->m_iXoffset+(iIndex*pDoc->m_iWidth),pDoc->m_iYoffset);
		pDC->LineTo(pDoc->m_iXoffset+(iIndex*pDoc->m_iWidth),pDoc->m_iYoffset+(pDoc->m_iHeight*pDoc->m_iRow));		
	}
	for(iIndex=0;iIndex<=pDoc->m_iRow;iIndex++)
	{
		pDC->MoveTo(pDoc->m_iXoffset,pDoc->m_iYoffset+(iIndex*pDoc->m_iHeight));
		pDC->LineTo(pDoc->m_iXoffset+(pDoc->m_iWidth*pDoc->m_iColoums),pDoc->m_iYoffset+(iIndex*pDoc->m_iHeight));
	}
}

void CMatrixGridView::OnZoom25() 
{
	AfxMessageBox("Add code for Zooming 25 % here");	
}

void CMatrixGridView::OnZoom50() 
{
	AfxMessageBox("Add code for Zooming 50 % here");
	
}

void CMatrixGridView::OnZoom200() 
{
	AfxMessageBox("Add code for Zooming 200 % here");
	
}

void CMatrixGridView::OnZoom100() 
{
	AfxMessageBox("Add code for Zooming 100 % here");
	
}

void CMatrixGridView::OnEditUndo() 
{
	AfxMessageBox("Add code for Undo Operation here");
	
}

void CMatrixGridView::OnEditPaste() 
{
	AfxMessageBox("Add code for Paste Operation here");
	
}

void CMatrixGridView::OnEditCut() 
{
	AfxMessageBox("Add code for Cut Operation here");
	
}

void CMatrixGridView::OnEditCopy() 
{
	AfxMessageBox("Add code for Copy Operation here");
	
}
